#include <stdio.h>
#include <string.h>
#include <malloc.h>

int main()
{
    int min(int, int);
    int BrojSlovaIzmedju(char[], int);
    void ObrniString(char*);

    char str[3000] = {};
    char** delici;

    gets(str);

    int n = strlen(str);
    int* niz;
    int brojac = 0;

    niz = (int*)calloc(n / 2, sizeof(int));

    for (int i = 0; i < n; ++i)
    {
        int j;
        int najkraceRast = 0;
        for (j = i; j < n; ++j)
        {
            int trenRastojanje = BrojSlovaIzmedju(str, j);

            if (trenRastojanje % 2 == 1)
            {
                if (najkraceRast == 0 || trenRastojanje < najkraceRast)
                {
                    najkraceRast = trenRastojanje;
                    continue;
                }
                else
                {
                    break;
                }
            }
            else
            {
                if (najkraceRast != 0)
                {
                    break;
                }
            }
        }
        niz[brojac++] = j + najkraceRast / 2 - 1;
        i = j + najkraceRast / 2;
    }

    delici = (char**)calloc(brojac, sizeof(char*));

    int DoSadZapisano = 0;
    for (int i = 0; i < brojac; ++i)
    {
        delici[i] = (char*)calloc(niz[i], sizeof(char));
    }

    for (int i = 0; i <= niz[0]; ++i)
    {
        delici[0][i] = str[DoSadZapisano++];
    }

    int BrojPoklopljenih = 0;

    for (int i = 1; i < brojac; ++i)
    {
        for (int j = 0; j < niz[i] - niz[i - 1]; ++j)
        {
            delici[i][j] = str[DoSadZapisano++];
        }

        int m = min(strlen(delici[i - 1]), strlen(delici[i]));
        int I;
        int J;

        if (i % 2 == 1)
        {
            ObrniString(delici[i]);
            I = strlen(delici[i - 1]) - 1;
            J = strlen(delici[i]) - 1;
        }
        else
        {
            I = 0;
            J = 0;
        }

        for (int br = 0; br < m; ++br)
        {
            BrojPoklopljenih += delici[i - 1][I] == delici[i][J];

            if (i % 2 == 1)
            {
                I--;
                J--;
            }
            else
            {
                I++;
                J++;
            }
        }
    }

    printf("%d", BrojPoklopljenih);
}

int min(int Broj1, int Broj2)
{
    return (Broj1 < Broj2) ? Broj1 : Broj2;
}

int BrojSlovaIzmedju(char str[], int i)
{
    char c = str[i];
    int br = 0;
    int n = strlen(str);

    for (int j = i + 1; j < n; ++j)
    {
        br++;
        if (str[j] == c)
        {
            return br;
        }
    }

    return 0;
}

void ObrniString(char* str)
{
    int n = strlen(str);

    for (int i = 0, j = n - 1; i < n / 2; ++i, --j)
    {
        char smena = str[i];
        str[i] = str[j];
        str[j] = smena;
    }
}